SELECT 
T0.Code AS 'BudgetCode',
CASE T0.U_BOY_DATA_TYPE
WHEN 1 THEN T0.Name + ' - Business Partner Group - '+CAST(T0.U_BOY_YEAR AS VARCHAR(4))
WHEN 2 THEN T0.Name + ' - Business Partner - '+CAST(T0.U_BOY_YEAR AS VARCHAR(4))
WHEN 3 THEN T0.Name + ' - Item Group - '+CAST(T0.U_BOY_YEAR AS VARCHAR(4))
WHEN 4 THEN T0.Name + ' - Item - '+CAST(T0.U_BOY_YEAR AS VARCHAR(4))
END AS 'BudgetId',
T0.Name AS 'BudgetName',
CASE T0.U_BOY_DATA_TYPE
WHEN 1 THEN 'Business Partner Group'
WHEN 2 THEN 'Business Partner'
WHEN 3 THEN 'Item Group'
WHEN 4 THEN 'Item'
END AS 'BudgetType',
T0.U_BOY_YEAR AS 'BudgetYear',
T0.U_BOY_COMMENTS AS 'BudgetComments',
DATEADD(MONTH, T2.U_BOY_MONTH-1, CAST(T0.U_BOY_YEAR AS NVARCHAR(4))+RIGHT(REPLICATE('0',1)+CAST(T0.U_BOY_MONTH AS NVARCHAR(2)), 2)+'01') AS 'Date',
T1.U_BOY_DATA_KEY AS 'DataEntry',
CASE T0.U_BOY_DATA_TYPE
WHEN 1 THEN (SELECT TS0.GroupName FROM OCRG TS0 WHERE TS0.GroupCode = T1.U_BOY_DATA_KEY)
WHEN 2 THEN (SELECT TS0.CardName FROM OCRD TS0 WHERE TS0.CardCode = T1.U_BOY_DATA_KEY)
WHEN 3 THEN (SELECT TS0.ItmsGrpNam FROM OITB TS0 WHERE TS0.ItmsGrpCod = T1.U_BOY_DATA_KEY)
WHEN 4 THEN (SELECT TS0.ItemName FROM OITM TS0 WHERE TS0.ItemCode = T1.U_BOY_DATA_KEY)
END AS 'DataEntryName',
T2.U_BOY_CREDIT-T2.U_BOY_DEBIT AS 'BudgetValue',
CASE T0.U_BOY_DATA_TYPE
WHEN 1 THEN 
ISNULL(
           (
					  (
                                 SELECT ISNULL(SUM(TS0.LineTotal-(TS0.LineTotal*TS1.DiscPrcnt/100)), 0) 
                                 FROM INV1 TS0
                                 JOIN OINV TS1 ON TS0.DocEntry = TS1.DocEntry
                                 WHERE TS1.CardCode IN 
								 (
									SELECT 
									TSS0.Cardcode 
									FROM OCRD TSS0
									WHERE CAST(TSS0.GroupCode AS NVARCHAR(100)) = T1.U_BOY_DATA_KEY
								 ) 
                                 AND TS1.DocDate BETWEEN DATEADD(MONTH, T2.U_BOY_MONTH-1, CAST(T0.U_BOY_YEAR AS NVARCHAR(4))+RIGHT(REPLICATE('0',1)+CAST(T0.U_BOY_MONTH AS NVARCHAR(2)), 2)+'01') AND DATEADD(DAY, -1, (DATEADD(MONTH, T2.U_BOY_MONTH, CAST(T0.U_BOY_YEAR AS NVARCHAR(4))+RIGHT(REPLICATE('0',1)+CAST(T0.U_BOY_MONTH AS NVARCHAR(2)), 2)+'01')))
                                 AND (TS0.SlpCode = T1.U_BOY_SEMP OR T1.U_BOY_SEMP = -999)
                                 AND (ISNULL(TS0.Project,'') = T1.U_BOY_PROJ OR T1.U_BOY_PROJ = '-999')
                                 AND (ISNULL(TS0.OcrCode,'') = T1.U_BOY_PC OR T1.U_BOY_PC = '-999')                                 
                      )
                      -
                      (
                                 SELECT ISNULL(SUM(TS0.LineTotal-(TS0.LineTotal*TS1.DiscPrcnt/100)), 0) 
                                 FROM RIN1 TS0
                                 JOIN ORIN TS1 ON TS0.DocEntry = TS1.DocEntry
                                 WHERE TS1.CardCode IN 
								 (
									SELECT 
									TSS0.Cardcode 
									FROM OCRD TSS0
									WHERE CAST(TSS0.GroupCode AS NVARCHAR(100)) = T1.U_BOY_DATA_KEY
								 ) 
                                 AND TS1.DocDate BETWEEN DATEADD(MONTH, T2.U_BOY_MONTH-1, CAST(T0.U_BOY_YEAR AS NVARCHAR(4))+RIGHT(REPLICATE('0',1)+CAST(T0.U_BOY_MONTH AS NVARCHAR(2)), 2)+'01') AND DATEADD(DAY, -1, (DATEADD(MONTH, T2.U_BOY_MONTH, CAST(T0.U_BOY_YEAR AS NVARCHAR(4))+RIGHT(REPLICATE('0',1)+CAST(T0.U_BOY_MONTH AS NVARCHAR(2)), 2)+'01')))
                                 AND (TS0.SlpCode = T1.U_BOY_SEMP OR T1.U_BOY_SEMP = -999)
                                 AND (ISNULL(TS0.Project,'') = T1.U_BOY_PROJ OR T1.U_BOY_PROJ = '-999')
                                 AND (ISNULL(TS0.OcrCode,'') = T1.U_BOY_PC OR T1.U_BOY_PC = '-999')                                 
                      )           
           )
,0) 
WHEN 2 THEN 
ISNULL(
           (
					  (
                                 SELECT ISNULL(SUM(TS0.LineTotal-(TS0.LineTotal*TS1.DiscPrcnt/100)), 0) 
                                 FROM INV1 TS0
                                 JOIN OINV TS1 ON TS0.DocEntry = TS1.DocEntry
                                 WHERE TS1.CardCode = T1.U_BOY_DATA_KEY 
                                 AND TS1.DocDate BETWEEN DATEADD(MONTH, T2.U_BOY_MONTH-1, CAST(T0.U_BOY_YEAR AS NVARCHAR(4))+RIGHT(REPLICATE('0',1)+CAST(T0.U_BOY_MONTH AS NVARCHAR(2)), 2)+'01') AND DATEADD(DAY, -1, (DATEADD(MONTH, T2.U_BOY_MONTH, CAST(T0.U_BOY_YEAR AS NVARCHAR(4))+RIGHT(REPLICATE('0',1)+CAST(T0.U_BOY_MONTH AS NVARCHAR(2)), 2)+'01')))
                                 AND (TS0.SlpCode = T1.U_BOY_SEMP OR T1.U_BOY_SEMP = -999)
                                 AND (ISNULL(TS0.Project,'') = T1.U_BOY_PROJ OR T1.U_BOY_PROJ = '-999')
                                 AND (ISNULL(TS0.OcrCode,'') = T1.U_BOY_PC OR T1.U_BOY_PC = '-999')                                 
                      )
                      -
                      (
                                 SELECT ISNULL(SUM(TS0.LineTotal-(TS0.LineTotal*TS1.DiscPrcnt/100)), 0) 
                                 FROM RIN1 TS0
                                 JOIN ORIN TS1 ON TS0.DocEntry = TS1.DocEntry
                                 WHERE TS1.CardCode = T1.U_BOY_DATA_KEY 
                                 AND TS1.DocDate BETWEEN DATEADD(MONTH, T2.U_BOY_MONTH-1, CAST(T0.U_BOY_YEAR AS NVARCHAR(4))+RIGHT(REPLICATE('0',1)+CAST(T0.U_BOY_MONTH AS NVARCHAR(2)), 2)+'01') AND DATEADD(DAY, -1, (DATEADD(MONTH, T2.U_BOY_MONTH, CAST(T0.U_BOY_YEAR AS NVARCHAR(4))+RIGHT(REPLICATE('0',1)+CAST(T0.U_BOY_MONTH AS NVARCHAR(2)), 2)+'01')))
                                 AND (TS0.SlpCode = T1.U_BOY_SEMP OR T1.U_BOY_SEMP = -999)
                                 AND (ISNULL(TS0.Project,'') = T1.U_BOY_PROJ OR T1.U_BOY_PROJ = '-999')
                                 AND (ISNULL(TS0.OcrCode,'') = T1.U_BOY_PC OR T1.U_BOY_PC = '-999')                                 
                      )
           ) 
,0)
WHEN 3 THEN 
ISNULL(
           (
                      (
                                 SELECT ISNULL(SUM(TS0.LineTotal-(TS0.LineTotal*TS1.DiscPrcnt/100)), 0) 
                                 FROM INV1 TS0
                                 JOIN OINV TS1 ON TS0.DocEntry = TS1.DocEntry
                                 WHERE TS0.ItemCode IN 
                                 (
                                            SELECT 
                                            TSS0.ItemCode 
                                            FROM OITM TSS0
                                            WHERE CAST(TSS0.ItmsGrpCod AS NVARCHAR(100)) = T1.U_BOY_DATA_KEY
                                 )
                                 AND TS1.DocDate BETWEEN DATEADD(MONTH, T2.U_BOY_MONTH-1, CAST(T0.U_BOY_YEAR AS NVARCHAR(4))+RIGHT(REPLICATE('0',1)+CAST(T0.U_BOY_MONTH AS NVARCHAR(2)), 2)+'01') AND DATEADD(DAY, -1, (DATEADD(MONTH, T2.U_BOY_MONTH, CAST(T0.U_BOY_YEAR AS NVARCHAR(4))+RIGHT(REPLICATE('0',1)+CAST(T0.U_BOY_MONTH AS NVARCHAR(2)), 2)+'01')))
                                 AND (TS0.SlpCode = T1.U_BOY_SEMP OR T1.U_BOY_SEMP = -999)
                                 AND (ISNULL(TS0.Project,'') = T1.U_BOY_PROJ OR T1.U_BOY_PROJ = '-999')
                                 AND (ISNULL(TS0.OcrCode,'') = T1.U_BOY_PC OR T1.U_BOY_PC = '-999')                                 
                      )                                
                      - 
                      (
                                 SELECT ISNULL(SUM(TS0.LineTotal-(TS0.LineTotal*TS1.DiscPrcnt/100)), 0) 
                                 FROM RIN1 TS0
                                 JOIN ORIN TS1 ON TS0.DocEntry = TS1.DocEntry
                                 WHERE TS0.ItemCode IN 
                                 (
                                            SELECT 
                                            TSS0.ItemCode 
                                            FROM 
                                            OITM TSS0
                                            WHERE CAST(TSS0.ItmsGrpCod AS NVARCHAR(100)) = T1.U_BOY_DATA_KEY
                                 ) 
                                 AND TS1.DocDate BETWEEN DATEADD(MONTH, T2.U_BOY_MONTH-1, CAST(T0.U_BOY_YEAR AS NVARCHAR(4))+RIGHT(REPLICATE('0',1)+CAST(T0.U_BOY_MONTH AS NVARCHAR(2)), 2)+'01') AND DATEADD(DAY, -1, (DATEADD(MONTH, T2.U_BOY_MONTH, CAST(T0.U_BOY_YEAR AS NVARCHAR(4))+RIGHT(REPLICATE('0',1)+CAST(T0.U_BOY_MONTH AS NVARCHAR(2)), 2)+'01')))
                                 AND (TS0.SlpCode = T1.U_BOY_SEMP OR T1.U_BOY_SEMP = -999)
                                 AND (ISNULL(TS0.Project,'') = T1.U_BOY_PROJ OR T1.U_BOY_PROJ = '-999')
                                 AND (ISNULL(TS0.OcrCode,'') = T1.U_BOY_PC OR T1.U_BOY_PC = '-999')                                 
                      )
           )
,0)
WHEN 4 THEN 
ISNULL(
           (
                      (
                                 SELECT ISNULL(SUM(TS0.LineTotal-(TS0.LineTotal*TS1.DiscPrcnt/100)), 0) 
                                 FROM INV1 TS0
                                 JOIN OINV TS1 ON TS0.DocEntry = TS1.DocEntry
                                 WHERE TS0.ItemCode = T1.U_BOY_DATA_KEY 
                                 AND TS1.DocDate BETWEEN DATEADD(MONTH, T2.U_BOY_MONTH-1, CAST(T0.U_BOY_YEAR AS NVARCHAR(4))+RIGHT(REPLICATE('0',1)+CAST(T0.U_BOY_MONTH AS NVARCHAR(2)), 2)+'01') AND DATEADD(DAY, -1, (DATEADD(MONTH, T2.U_BOY_MONTH, CAST(T0.U_BOY_YEAR AS NVARCHAR(4))+RIGHT(REPLICATE('0',1)+CAST(T0.U_BOY_MONTH AS NVARCHAR(2)), 2)+'01')))
                                 AND (TS0.SlpCode = T1.U_BOY_SEMP OR T1.U_BOY_SEMP = -999)
                                 AND (ISNULL(TS0.Project,'') = T1.U_BOY_PROJ OR T1.U_BOY_PROJ = '-999')
                                 AND (ISNULL(TS0.OcrCode,'') = T1.U_BOY_PC OR T1.U_BOY_PC = '-999')                                 
                      )
                      -
                      (
                                 SELECT ISNULL(SUM(TS0.LineTotal-(TS0.LineTotal*TS1.DiscPrcnt/100)), 0) 
                                 FROM RIN1 TS0
                                 JOIN ORIN TS1 ON TS0.DocEntry = TS1.DocEntry
                                 WHERE TS0.ItemCode = T1.U_BOY_DATA_KEY 
                                 AND TS1.DocDate BETWEEN DATEADD(MONTH, T2.U_BOY_MONTH-1, CAST(T0.U_BOY_YEAR AS NVARCHAR(4))+RIGHT(REPLICATE('0',1)+CAST(T0.U_BOY_MONTH AS NVARCHAR(2)), 2)+'01') AND DATEADD(DAY, -1, (DATEADD(MONTH, T2.U_BOY_MONTH, CAST(T0.U_BOY_YEAR AS NVARCHAR(4))+RIGHT(REPLICATE('0',1)+CAST(T0.U_BOY_MONTH AS NVARCHAR(2)), 2)+'01')))
                                 AND (TS0.SlpCode = T1.U_BOY_SEMP OR T1.U_BOY_SEMP = -999)
                                 AND (ISNULL(TS0.Project,'') = T1.U_BOY_PROJ OR T1.U_BOY_PROJ = '-999')
                                 AND (ISNULL(TS0.OcrCode,'') = T1.U_BOY_PC OR T1.U_BOY_PC = '-999')                                 
                      )
           )
,0)
END AS 'ActualValue',
T1.U_BOY_SEMP AS SalesEmployeeCode,
T1.U_BOY_PROJ AS ProjectCode,
T1.U_BOY_PC AS ProfitCenterCode,
CASE T1.U_BOY_SEMP WHEN -999 THEN '-Not defined-' ELSE (SELECT SlpName FROM OSLP WHERE SlpCode = T1.U_BOY_SEMP) END AS 'SalesEmployee',
CASE T1.U_BOY_PROJ WHEN '-999' THEN '-Not defined-' ELSE (SELECT PrjName FROM OPRJ WHERE PrjCode = T1.U_BOY_PROJ) END AS 'Project',
CASE T1.U_BOY_PC WHEN '-999' THEN '- Not defined-' ELSE (SELECT OcrName FROM OOCR WHERE OcrCode = T1.U_BOY_PC) END AS 'ProfitCenter'
FROM [@BOY_90_BUD] T0 
JOIN [@BOY_90_BUD_ENTRY] T1 ON T0.Code = T1.U_BOY_BUDGET_FK
JOIN [@BOY_90_BUD_ENTRY_M] T2 ON T1.Code = T2.U_BOY_ENTRY_FK
