using Boyum.Plugin;
using SAPbouiCOM;

namespace MyFirstPlugin
{
    public class MyPlugin : PluginAdapter
    {
        public MyPlugin()
        {
            //Here you setup a productidentifer and if a license-check should occur. For demo purpose so far just ignore them but they would need to be here and the 
            //Identifier needs to be unique
            //LicenseCheck = true;
            ProductIdentifier = "BOY_TESTPLUGIN";
        }

        public override void SetupMenuItems()
        {
            base.SetupMenuItems();

            //Create a new menu-item under Help topmenu
            Menus subMenus = SboApplication.Menus.Item("43564").SubMenus; //SboApplication is the UI-API connection
            if (!subMenus.Exists("BOY_MI1"))
            {
                MenuCreationParams menuItem = (MenuCreationParams)SboApplication.CreateObject(BoCreatableObjectType.cot_MenuCreationParams);
                menuItem.String = "My Menuitem for DB - " + SboCompany.CompanyDB; //Sbocompany is the DI-API connection
                menuItem.UniqueID = "BOY_MI1";
                menuItem.Position = 999;
                menuItem.Type = BoMenuType.mt_STRING;
                subMenus.AddEx(menuItem);
            }
        }

        public override AddonEventFilter SetupEventFilter()
        {
            //Set up the event-filter
            EventFilter.Add(BoEventTypes.et_MENU_CLICK);

            return EventFilter;
        }

        public override void MenuEvent(ref MenuEvent pVal, out bool bubbleEvent)
        {
            base.MenuEvent(ref pVal, out bubbleEvent);

            switch (pVal.MenuUID)
            {
                case "BOY_MI1":
                    if (!pVal.BeforeAction)
                    {
                        //Show a message on menu-click
                        SboApplication.MessageBox("Hello My first Plugin", 1, "OK", "", "");
                    }
                    break;
            }
        }

        public override void RemoveMenuItems()
        {
            base.RemoveMenuItems();

            //Remove menu-item on stop of add-on
            Menus subMenus = SboApplication.Menus.Item("43564").SubMenus;
            if (subMenus.Exists("BOY_MI1"))
            {
                SboApplication.Menus.RemoveEx("BOY_MI1");
            }
        }
    }
}