﻿Imports SAPbouiCOM
Imports Boyum.Plugin

Public Class MyFirstPlugin
    Inherits PluginAdapter

    Public Sub New()
        ProductIdentifier = "BOY_TESTPLUGIN"
    End Sub

    Public Overrides Function SetupEventFilter() As Boyum.Plugin.AddonEventFilter
        'Set up the event-filter
        EventFilter.Add(BoEventTypes.et_MENU_CLICK)
        Return EventFilter
    End Function

    Public Overrides Sub SetupMenuItems()
        MyBase.SetupMenuItems()

        'Create a new menu-item under Help topmenu
        Dim subMenus As Menus = SboApplication.Menus.Item("43564").SubMenus 'SboApplication is the UI-API connection

        If (Not subMenus.Exists("BOY_MI1")) Then
            Dim menuItem As MenuCreationParams = SboApplication.CreateObject(BoCreatableObjectType.cot_MenuCreationParams)

            menuItem.String = "My Menuitem for DB - " + SboCompany.CompanyDB 'Sbocompany is the DI-API connection
            MenuItem.UniqueID = "BOY_MI1"
            MenuItem.Position = 999
            MenuItem.Type = BoMenuType.mt_STRING
            subMenus.AddEx(menuItem)
        End If

    End Sub

    Public Overrides Sub RemoveMenuItems()
        MyBase.RemoveMenuItems()

        'Remove menu-item on stop of add-on
        Dim subMenus As Menus = SboApplication.Menus.Item("43564").SubMenus
        If (subMenus.Exists("BOY_MI1")) Then
            SboApplication.Menus.RemoveEx("BOY_MI1")
        End If
    End Sub

    Public Overrides Sub MenuEvent(ByRef pVal As SAPbouiCOM.MenuEvent, ByRef bubbleEvent As Boolean)
        MyBase.MenuEvent(pVal, bubbleEvent)

        Select Case pVal.MenuUID
            Case "BOY_MI1"
                If (Not pVal.BeforeAction) Then
                    SboApplication.MessageBox("Hello My first Plugin")
                End If
        End Select
    End Sub
End Class
